
#include "LinearAlgebra.h"
#include <vector>
#include <Qt/qmap.h>

#ifndef __CALCULUS_H
#define __CALCULUS_H

class FFTManager
{
	public:	
		struct FFTWorkspace
		{			
			int n;
			gsl_fft_complex_wavetable * m_pTrigonometricTable;
			gsl_fft_complex_workspace * m_pWorkspace;			
			gsl_complex_packed_array m_RowArray;
		};
		void FFT2D(SymMatrix2D & src, SymMatrix2DComplex & trg);
		void IFFT2D(SymMatrix2DComplex & src, SymMatrix2DComplex & trg);
		void FFT1DRow(SymMatrix2D & src, SymMatrix2DComplex & trg);
		void IFFT1DRow(SymMatrix2DComplex & src, SymMatrix2DComplex & trg);
		void FFT1DCol(SymMatrix2D & src, SymMatrix2DComplex & trg);
		void IFFT1DCol(SymMatrix2DComplex & src, SymMatrix2DComplex & trg);

	
		FFTWorkspace Get1DWorkspace(int n);
		void Clear1DWorkspace(int n);
	
		//testing
		static void TestFFT2D();
	
		QMap<int,  FFTWorkspace> m_WorkspaceTable;
};

class NumericalMethods
{
	public:
		static void IntegratedLagrangianWghts(std::vector<double> & smplLoc, std::vector<double> & w, int m);
		static void TestIntegration();
		static void TestIntegration2D();
	
	protected:
		static double IntegrateLagrangianInterpolant(int id, std::vector<double> & smplLoc, 
													 int m, int minID, int maxID, int interval);
};

#endif
