#include "DeformImageWarping.h"
#include <iostream>
#include <time.h>

ImageWarp::ImagePenalization::ImagePenalization()
{
	m_iFields = FOLDOVER_BINARY;
}

ImageWarp::ImageHierarchyDescriptor::ImageHierarchyDescriptor()
{
	m_HierarchyType = CONST_CHILDREN;  
	m_iAssocX = 2;
	m_iAssocY = 2;
	m_iMinPnts = 1;
	m_iInitNumPntsX = -1;
	m_iInitNumPntsY = -1;
}


ImageWarp::ImageWarp(QImage & img)
{
	m_Source = img;
	m_Deformed = img;

	m_pSourceMatrix = new SymMatrix2DReal(img.width(), img.height());
	m_pDeformedMatrix =  new SymMatrix2DReal(img.width(), img.height());
	for (int i=0; i<img.width(); i++)
	{
		for (int j=0; j<img.height(); j++)
		{
			QRgb color = img.pixel(i,j);			
			double & val = (*m_pSourceMatrix)(i,j);
			val = 0.3*qRed(color)/255 + 0.59*qGreen(color)/255 + 0.11*qBlue(color)/255;
		}
	}
}

bool ImageWarp::HasOutput(OutputType type)
{
	return type==DEFORM_OUT_IMG2D || type==DEFORM_OUT_SYMREAL2D;
}

void ImageWarp::ImgVertex::AddAdjacentVertex(int vertex)
{
	if (vertex<0) 
		return;
	
	for (int i=0; i<(int)m_AdjacentVertices.size(); i++)
		if (vertex==m_AdjacentVertices[i])
			return;
	m_AdjacentVertices.push_back(vertex);
}


